summaryrefslogtreecommitdiff
path: root/build-aux
diff options
context:
space:
mode:
Diffstat (limited to 'build-aux')
-rw-r--r--build-aux/check-available-binaries.scm5
-rw-r--r--build-aux/hydra/evaluate.scm98
-rw-r--r--build-aux/hydra/gnu-system.scm35
-rw-r--r--build-aux/pre-inst-env.in71
-rw-r--r--build-aux/test-env.in131
5 files changed, 323 insertions, 17 deletions
diff --git a/build-aux/check-available-binaries.scm b/build-aux/check-available-binaries.scm
index e7db70bba9..0060a8669e 100644
--- a/build-aux/check-available-binaries.scm
+++ b/build-aux/check-available-binaries.scm
@@ -46,8 +46,9 @@
(available (substitutable-paths store total))
(missing (lset-difference string=? total available)))
(if (null? missing)
- (format (current-error-port) "~a packages found substitutable~%"
- (length total))
+ (format (current-error-port)
+ "~a packages found substitutable on~{ ~a~}~%"
+ (length total) %hydra-supported-systems)
(format (current-error-port)
"~a packages are not substitutable:~%~{ ~a~%~}~%"
(length missing) missing))
diff --git a/build-aux/hydra/evaluate.scm b/build-aux/hydra/evaluate.scm
new file mode 100644
index 0000000000..afc7730ff2
--- /dev/null
+++ b/build-aux/hydra/evaluate.scm
@@ -0,0 +1,98 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright © 2016 Ludovic Courtès <ludo@gnu.org>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix. If not, see <http://www.gnu.org/licenses/>.
+
+;;; This program replicates the behavior of Hydra's 'hydra-eval-guile-job'.
+;;; It evaluates the Hydra job defined by the program passed as its first
+;;; arguments and outputs an sexp of the jobs on standard output.
+
+(use-modules (guix store)
+ (srfi srfi-19)
+ (ice-9 match)
+ (ice-9 pretty-print)
+ (ice-9 format))
+
+(define %user-module
+ ;; Hydra user module.
+ (let ((m (make-module)))
+ (beautify-user-module! m)
+ m))
+
+(define (call-with-time thunk kont)
+ "Call THUNK and pass KONT the elapsed time followed by THUNK's return
+values."
+ (let* ((start (current-time time-monotonic))
+ (result (call-with-values thunk list))
+ (end (current-time time-monotonic)))
+ (apply kont (time-difference end start) result)))
+
+(define (call-with-time-display thunk)
+ "Call THUNK and write to the current output port its duration."
+ (call-with-time thunk
+ (lambda (time . results)
+ (format #t "~,3f seconds~%"
+ (+ (time-second time)
+ (/ (time-nanosecond time) 1e9)))
+ (apply values results))))
+
+
+;; Without further ado...
+(match (command-line)
+ ((command file)
+ ;; Load FILE, a Scheme file that defines Hydra jobs.
+ (let ((port (current-output-port)))
+ (save-module-excursion
+ (lambda ()
+ (set-current-module %user-module)
+ (primitive-load file)))
+
+ (with-store store
+ ;; Make sure we don't resort to substitutes.
+ (set-build-options store
+ #:use-substitutes? #f
+ #:substitute-urls '())
+
+ ;; Grafts can trigger early builds. We do not want that to happen
+ ;; during evaluation, so use a sledgehammer to catch such problems.
+ (set! build-things
+ (lambda (store . args)
+ (format (current-error-port)
+ "error: trying to build things during evaluation!~%")
+ (format (current-error-port)
+ "'build-things' arguments: ~s~%" args)
+ (exit 1)))
+
+ ;; Call the entry point of FILE and print the resulting job sexp.
+ (pretty-print
+ (match ((module-ref %user-module 'hydra-jobs) store '())
+ (((names . thunks) ...)
+ (map (lambda (job thunk)
+ (format (current-error-port) "evaluating '~a'... " job)
+ (force-output (current-error-port))
+ (cons job (call-with-time-display thunk)))
+ names thunks)))
+ port))))
+ ((command _ ...)
+ (format (current-error-port) "Usage: ~a FILE
+Evaluate the Hydra jobs defined in FILE.~%"
+ command)
+ (exit 1)))
+
+;;; Local Variables:
+;;; eval: (put 'call-with-time 'scheme-indent-function 1)
+;;; End:
+
diff --git a/build-aux/hydra/gnu-system.scm b/build-aux/hydra/gnu-system.scm
index 548d9e044a..d15be1bad2 100644
--- a/build-aux/hydra/gnu-system.scm
+++ b/build-aux/hydra/gnu-system.scm
@@ -71,19 +71,20 @@
(define* (package->alist store package system
#:optional (package-derivation package-derivation))
"Convert PACKAGE to an alist suitable for Hydra."
- `((derivation . ,(derivation-file-name
- (package-derivation store package system
- #:graft? #f)))
- (description . ,(package-synopsis package))
- (long-description . ,(package-description package))
- (license . ,(package-license package))
- (home-page . ,(package-home-page package))
- (maintainers . ("bug-guix@gnu.org"))
- (max-silent-time . ,(or (assoc-ref (package-properties package)
- 'max-silent-time)
- 3600)) ; 1 hour by default
- (timeout . ,(or (assoc-ref (package-properties package) 'timeout)
- 72000)))) ; 20 hours by default
+ (parameterize ((%graft? #f))
+ `((derivation . ,(derivation-file-name
+ (package-derivation store package system
+ #:graft? #f)))
+ (description . ,(package-synopsis package))
+ (long-description . ,(package-description package))
+ (license . ,(package-license package))
+ (home-page . ,(package-home-page package))
+ (maintainers . ("bug-guix@gnu.org"))
+ (max-silent-time . ,(or (assoc-ref (package-properties package)
+ 'max-silent-time)
+ 3600)) ;1 hour by default
+ (timeout . ,(or (assoc-ref (package-properties package) 'timeout)
+ 72000))))) ;20 hours by default
(define (package-job store job-name package system)
"Return a job called JOB-NAME that builds PACKAGE on SYSTEM."
@@ -142,7 +143,9 @@ system.")
(define (->job name drv)
(let ((name (symbol-append name (string->symbol ".")
(string->symbol system))))
- `(,name . ,(cut ->alist drv))))
+ `(,name . ,(lambda ()
+ (parameterize ((%graft? #f))
+ (->alist drv))))))
(define MiB
(expt 2 20))
@@ -178,7 +181,9 @@ all its dependencies, and ready to be installed on non-GuixSD distributions.")
(define (->job name drv)
(let ((name (symbol-append name (string->symbol ".")
(string->symbol system))))
- `(,name . ,(cut ->alist drv))))
+ `(,name . ,(lambda ()
+ (parameterize ((%graft? #f))
+ (->alist drv))))))
;; XXX: Add a job for the stable Guix?
(list (->job 'binary-tarball
diff --git a/build-aux/pre-inst-env.in b/build-aux/pre-inst-env.in
new file mode 100644
index 0000000000..fe56da6944
--- /dev/null
+++ b/build-aux/pre-inst-env.in
@@ -0,0 +1,71 @@
+#!/bin/sh
+
+# GNU Guix --- Functional package management for GNU
+# Copyright © 2012, 2013, 2014, 2015 Ludovic Courtès <ludo@gnu.org>
+#
+# This file is part of GNU Guix.
+#
+# GNU Guix is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# GNU Guix is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GNU Guix. If not, see <http://www.gnu.org/licenses/>.
+
+# Usage: ./pre-inst-env COMMAND ARG...
+#
+# Run COMMAND in a pre-installation environment. Typical use is
+# "./pre-inst-env guix build hello".
+
+# By default we may end up with absolute directory names that contain '..',
+# which get into $GUILE_LOAD_PATH, leading to '..' in the module file names
+# recorded by Guile. To avoid that, make sure we get a real absolute
+# directory name. Additionally, use '-P' to get the canonical directory name
+# so that Guile's 'relative' %file-port-name-canonicalization can actually
+# work (see <http://bugs.gnu.org/17935>.)
+abs_top_srcdir="`cd "@abs_top_srcdir@" > /dev/null; pwd -P`"
+abs_top_builddir="`cd "@abs_top_builddir@" > /dev/null; pwd -P`"
+
+GUILE_LOAD_COMPILED_PATH="$abs_top_builddir${GUILE_LOAD_COMPILED_PATH:+:}$GUILE_LOAD_COMPILED_PATH"
+GUILE_LOAD_PATH="$abs_top_builddir:$abs_top_srcdir${GUILE_LOAD_PATH:+:}$GUILE_LOAD_PATH"
+export GUILE_LOAD_COMPILED_PATH GUILE_LOAD_PATH
+
+# Define $PATH so that `guix' and friends are easily found.
+
+PATH="$abs_top_builddir/scripts:$abs_top_builddir:$PATH"
+export PATH
+
+# Daemon helpers.
+
+NIX_ROOT_FINDER="$abs_top_builddir/nix/scripts/list-runtime-roots"
+NIX_SUBSTITUTERS="$abs_top_builddir/nix/scripts/substitute"
+NIX_BUILD_HOOK="$abs_top_builddir/nix/scripts/offload"
+NIX_LIBEXEC_DIR="@abs_top_builddir@/nix/scripts" # for 'guix-authenticate'
+
+export NIX_ROOT_FINDER NIX_SUBSTITUTERS \
+ NIX_BUILD_HOOK NIX_LIBEXEC_DIR
+
+# The 'guix-register' program.
+GUIX_REGISTER="$abs_top_builddir/guix-register"
+export GUIX_REGISTER
+
+# The following variables need only be defined when compiling Guix
+# modules, but we define them to be on the safe side in case of
+# auto-compilation.
+
+NIX_HASH="@NIX_HASH@"
+export NIX_HASH
+
+# Define $GUIX_UNINSTALLED to prevent `guix' from
+# prepending @guilemoduledir@ to the Guile load paths.
+
+GUIX_UNINSTALLED=1
+export GUIX_UNINSTALLED
+
+exec "$@"
diff --git a/build-aux/test-env.in b/build-aux/test-env.in
new file mode 100644
index 0000000000..c3f60f7283
--- /dev/null
+++ b/build-aux/test-env.in
@@ -0,0 +1,131 @@
+#!/bin/sh
+
+# GNU Guix --- Functional package management for GNU
+# Copyright © 2012, 2013, 2014, 2015, 2016 Ludovic Courtès <ludo@gnu.org>
+#
+# This file is part of GNU Guix.
+#
+# GNU Guix is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# GNU Guix is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GNU Guix. If not, see <http://www.gnu.org/licenses/>.
+
+# Usage: ./test-env COMMAND ARG...
+#
+# Run the daemon in the build directory, and run COMMAND within
+# `pre-inst-env'. This is used to run unit tests with the just-built
+# daemon, unless `--disable-daemon' was passed at configure time.
+
+
+# Make sure 'cd' behaves deterministically and doesn't write anything to
+# stdout.
+unset CDPATH
+
+if [ -x "@abs_top_builddir@/guix-daemon" ]
+then
+ # Silence the daemon's output, which is often useless, as well as that of
+ # Bash (such as "Terminated" messages when 'guix-daemon' is killed.)
+ exec 2> /dev/null
+
+ NIX_STORE_DIR="@GUIX_TEST_ROOT@/store"
+
+ # Do that because store.scm calls `canonicalize-path' on it.
+ mkdir -p "$NIX_STORE_DIR"
+
+ # Canonicalize the store directory name in an attempt to avoid symlinks in
+ # it or its parent directories. See <http://bugs.gnu.org/17935>.
+ NIX_STORE_DIR="`cd "@GUIX_TEST_ROOT@/store"; pwd -P`"
+
+ NIX_LOCALSTATE_DIR="@GUIX_TEST_ROOT@/var"
+ NIX_LOG_DIR="@GUIX_TEST_ROOT@/var/log/guix"
+ NIX_DB_DIR="@GUIX_TEST_ROOT@/db"
+ NIX_ROOT_FINDER="@abs_top_builddir@/nix/scripts/list-runtime-roots"
+
+ # Choose a PID-dependent name to allow for parallel builds. Note
+ # that the directory name must be chosen so that the socket's file
+ # name is less than 108-char long (the size of `sun_path' in glibc).
+ # Currently, in Nix builds, we're at ~106 chars...
+ NIX_STATE_DIR="@GUIX_TEST_ROOT@/var/$$"
+
+ # We can't exit when we reach the limit, because perhaps the test doesn't
+ # actually rely on the daemon, but at least warn.
+ if test "`echo -n "$NIX_STATE_DIR/daemon-socket/socket" | wc -c`" -ge 108
+ then
+ echo "warning: exceeding socket file name limit; test may fail!" >&2
+ fi
+
+ # The configuration directory, for import/export signing keys.
+ NIX_CONF_DIR="@GUIX_TEST_ROOT@/etc"
+ if [ ! -d "$NIX_CONF_DIR" ]
+ then
+ # Copy the keys so that the secret key has the right permissions (the
+ # daemon errors out when this is not the case.)
+ mkdir -p "$NIX_CONF_DIR"
+ cp "@abs_top_srcdir@/tests/signing-key.sec" \
+ "@abs_top_srcdir@/tests/signing-key.pub" \
+ "$NIX_CONF_DIR"
+ chmod 400 "$NIX_CONF_DIR/signing-key.sec"
+ fi
+
+ # A place to store data of the substituter.
+ GUIX_BINARY_SUBSTITUTE_URL="file://$NIX_STATE_DIR/substituter-data"
+ rm -rf "$NIX_STATE_DIR/substituter-data"
+ mkdir -p "$NIX_STATE_DIR/substituter-data"
+
+ # For a number of tests, we want to allow unsigned narinfos, for
+ # simplicity.
+ GUIX_ALLOW_UNAUTHENTICATED_SUBSTITUTES=yes
+
+ # Place for the substituter's cache.
+ XDG_CACHE_HOME="$NIX_STATE_DIR/cache-$$"
+
+ # For the (guix import snix) tests.
+ NIXPKGS="@NIXPKGS@"
+
+ export NIX_IGNORE_SYMLINK_STORE NIX_STORE_DIR \
+ NIX_LOCALSTATE_DIR NIX_LOG_DIR NIX_STATE_DIR NIX_DB_DIR \
+ NIX_ROOT_FINDER GUIX_BINARY_SUBSTITUTE_URL \
+ GUIX_ALLOW_UNAUTHENTICATED_SUBSTITUTES \
+ NIX_CONF_DIR XDG_CACHE_HOME NIXPKGS
+
+ # Launch the daemon without chroot support because is may be
+ # unavailable, for instance if we're not running as root.
+ "@abs_top_builddir@/pre-inst-env" \
+ "@abs_top_builddir@/guix-daemon" --disable-chroot \
+ --substitute-urls="$GUIX_BINARY_SUBSTITUTE_URL" &
+
+ daemon_pid=$!
+ trap "kill $daemon_pid ; rm -rf $NIX_STATE_DIR" EXIT
+fi
+
+# Avoid issues that could stem from l10n, such as language/encoding
+# mismatches.
+unset LANGUAGE
+LC_MESSAGES=C
+export LC_MESSAGES
+
+# Disable grafts by default because they can cause things to be built
+# regardless of '--dry-run'.
+GUIX_BUILD_OPTIONS="--no-grafts"
+export GUIX_BUILD_OPTIONS
+
+# Ignore user settings.
+unset GUIX_PACKAGE_PATH
+
+storedir="@storedir@"
+prefix="@prefix@"
+datarootdir="@datarootdir@"
+datadir="@datadir@"
+localstatedir="@localstatedir@"
+export storedir prefix datarootdir datadir localstatedir
+
+"@abs_top_builddir@/pre-inst-env" "$@"
+exit $?